
function GamEngine(cvs){
	this.codeNames = [
		'titan','queen','elsa','nova','platinum','mamiru','Hell Hound','vampire','Boku Pico','MeatSpin','computer','world','mine','sexy','super','today','humor','ASKY','tokyo','yamakashi','make','New York','javascript','html','java','python','cat','serect','november','mask','annonimus', 'paypal','root','hack','apoclypse','wikipedia','group','alice','mirror','Wander Land','shin jjang',	'evangelion','negima','re-take','gainax','jibri', 'riot','AOS','null','void','Battle Fight','Space Ship','earth','Space AriForce', 
	];

	this.cvs = cvs;
	this.ctx = this.cvs.getContext("2d");
	this.infoDiv = [];

	this.effect = [];
	this._graphic = [];
	
	this.project = [];
	this.selectedProject = null;

	this.gameMod = {
		type:'normal',
		target:'null'
	};

	this.world;
	this.drawVars = {
			cvs:{
				synario:null,
				music:null,
				design:null,
				programming:null,
				graphics:null
			}, ctx:{
				synario:null,
				music:null,
				design:null,
				programming:null,
				graphics:null
			},
			cvsSize:{
				width:100,
				height:480
			},
			bodyArray:[],interval:null
		};
	this._startTime = new Date().getTime();
	this._timerInterval = null;

	this.gameDate = {
		year:1,
		month:1,
		date:1,
		absoluteTime:1,
		absoluteMilliTime:1,
		startedTime:0,
		delay:1
	};
	this.months = [31,28,31,31,30,31,31,30,31,30,31,30];

	this._delay = 0;
	this._isDelay = false;

	this._que = [];
	this.isWorking = false;

	this.clickTimes = 0;
	
	this.mainChar = null;
	this.charas = [];

	this.resource = {
		image:{}
	};

	this.reallocFunc = null;

	this.devType  = ["design","synario","programming","graphics","music"];
}

	GamEngine.prototype.admitInfoDiv = function(name,type){
		this.infoDiv.push({name:name,type:type});
	}

	GamEngine.prototype.setSpeed = function(speed){
		this.speed = speed;
	}

	GamEngine.prototype.runEngine = function(timer){
		if(!this.speed)
			this.speed = 60;
		if(!timer)
			var timer = 2000;
		/*
		this._interval = setInterval(function(engine){
			engine._calc();
			engine.draw();
		},1000/this.speed,this);
		*/
		this._timerInterval = setInterval(function(engine){
				var _now = new Date().getTime();
				var _interval = Math.round((_now - engine._startTime)/1000);

				engine.parseTimer(_interval);
			},timer,this);
	}
	GamEngine.prototype.stopEngine = function(type){
		clearInterval(this._interval);
		clearInterval(this._timerInterval);
		clearInterval(this.drawVars.interval);

		this.changeToNormalMod();
	}

	GamEngine.prototype.calc = function(){
		this.gameDate.absoluteMilliTime += 17;
		if(this.gameMod.type == "dev"){
			for(var id in this.charas){
				var _tempChar = this.charas[id];

				if(this.gameDate.absoluteMilliTime >= _tempChar.lastWork + _tempChar.workRate || _tempChar.lastWork == 0){
					_tempChar.lastWork = this.gameDate.absoluteMilliTime;
					this.dev(this.gameMod.target,"random",_tempChar);
				}
			}
		}
		for(var id in this.drawVars.bodyArray){
			this.drawVars.bodyArray[id].y++;
			if(this.drawVars.bodyArray[id].y >= 200){
				this.drawVars.bodyArray.splice(id,1);
			}
		}
		this.draw();
	}
	
	GamEngine.prototype.draw = function(){


		this.drawVars.cvs.synario.width = this.drawVars.cvs.synario.width;
		this.drawVars.cvs.music.width = this.drawVars.cvs.music.width;
		this.drawVars.cvs.graphics.width = this.drawVars.cvs.graphics.width;
		this.drawVars.cvs.programming.width = this.drawVars.cvs.programming.width;
		this.drawVars.cvs.design.width = this.drawVars.cvs.design.width;

		for(var id in this.drawVars.bodyArray){
			var body = this.drawVars.bodyArray[id];
			var _ctx = null;
			switch(body.type){
				case "design":
					_ctx = this.drawVars.ctx.design;
					break;

				case "music":
					_ctx = this.drawVars.ctx.music;
					break;
				case "programming":
					_ctx = this.drawVars.ctx.programming;
					break;
				case "synario":
					_ctx = this.drawVars.ctx.synario;
					break;
				case "graphics":
					_ctx = this.drawVars.ctx.graphics;
					break;
			}
			_ctx.drawImage(body.img,body.x,body.y,100,20);
		}
	}

	GamEngine.prototype.parseTimer = function(sec){

		this.gameDate.date++;
		this.gameDate.absoluteTime++;

		if(this.gameDate.absoluteTime >= this._delay){
			this._isDelay = false;
			this._delay = 0;

			$("#sceneDiv")
				.css("display","none")
				.css("z-index","-1");
		}

		for(var id in this._que){
			if(this.gameDate.absoluteTime >= this._que[id].delay){
				console.log('up');
				this._que[id].que();
				this._que.splice(id,1);
			}
		}

		if(this.gameDate.date > this.months[this.gameDate.month-1]){
			this.gameDate.date = 1;
			this.gameDate.month++;

			if(this.gameDate.month > 12){
				this.gameDate.year++;
				this.gameDate.month = 1;
				
				this.endOfYear();
				$("#year_1st_digit").html(Math.floor(this.gameDate.year/10));
				$("#year_2nd_digit").html(this.gameDate.year%10);
				$("#month_1st_digit").html(Math.floor(this.gameDate.month/10));
				$("#month_2nd_digit").html(this.gameDate.month%10);
				$("#day_1st_digit").html(Math.floor(this.gameDate.date/10));
				$("#day_2nd_digit").html(this.gameDate.date%10);
			} else {
				this.endOfMonth();
				$("#month_1st_digit").html(Math.floor(this.gameDate.month/10));
				$("#month_2nd_digit").html(this.gameDate.month%10);
				$("#day_1st_digit").html(Math.floor(this.gameDate.date/10));
				$("#day_2nd_digit").html(this.gameDate.date%10);
			}
		} else {
			this.endOfDay();
			$("#day_1st_digit").html(Math.floor(this.gameDate.date/10));
			$("#day_2nd_digit").html(this.gameDate.date%10);
		}

	}

	GamEngine.prototype.endOfDay = function(){
		console.log("end of day");
	}
	GamEngine.prototype.endOfMonth = function(){
		this.changeMoney(-400);

		for(var id in this.charas){
			var payment = this.charas[id].payment;
			this.changeMoney(-payment);
			console.log(payment);
		}
		if(this.mainChar.getMoney()<=0){
			this.gameOver();
		}
		console.log("생활비 명목으로 돈이 줄어듭니다.");
	}
	GamEngine.prototype.endOfYear = function(){
		console.log("end of Year");
	}

	GamEngine.prototype.createCharacter = function(name,seed){
		var _character = new Character(name);
		_character.randomStatus(seed);

		if(!this.mainChar)
			this.mainChar = _character;
		return _character;
	}

	GamEngine.prototype.createGameProject = function(name,type){
		var _pro = new Project();
		
		_pro.setName(name);
		_pro.setType(type);
		_pro.setCharacter(this.mainChar);

		this.project.push(_pro);
		var _index = this.project.indexOf(_pro);

		if(_index != null){
			console.log(_index);
			$("#presentProject").append(
					$("<div>")
					.attr("id","project"+_index)
					.attr("class","projectItem")
					.append(
						$("<div>")
							.css("cursor","pointer")
							//.css("border","1px solid #DE3B1D")
							.css("background-color","#45055B")
							.css("border-radius","5px")
						)
					.append($("<br />"))
					.append(
						$("<span>")
							.attr("class","ProjectName")
							.css("font-size","20px")
							.css("display","block")
							.css("white-space","nowrap")
							.css("overflow","hidden")
							.css("margin","-20px 0 0 0")
							.css("float","0 auto")
							.html(name))
					.click((function(thisClass,thisProject){
								return function(e){
									thisClass.changeToDevelopingMod(thisProject);
								};
							})(this,_pro)
					)
				);
		}

		this.reallocFunc();
	}

	GamEngine.prototype.finishProject = function(game){
		var _id = 0;
		if(typeof(game) == "string"){
			for(var id in this.project){
				if(this.project[id].getName() == game){
					this.project[id].finishProject();
					_id = id;
					break;
				}
			}
		} else {
			game.finishProject();
			changeMoney.this(game.earnMoney);
		}


		$("#project"+_id)
			.empty()
			.remove();
		//this.project.splice(_id,1);
		this.changeToNormalMod();
		this.reallocFunc();
	}

	GamEngine.prototype.changeMoney = function(value){
		this.mainChar.changeMoney(value);
		console.log(this.mainChar.money);
		$("#money .info").html(this.mainChar.money);
	}

	GamEngine.prototype.changeToDevelopingMod = function(project){
		if(this.gameMod.type != "dev" || this.gameMod.target != project.getName()){
			this.selectedProject = project;
			if(this.drawVars)
				clearInterval(this.drawVars.interval);
			this.gameMod.type = "dev";
			this.gameMod.target = project.getName();

			$("#completeProjectDiv")
				.css("display","block")
				.click((function(thisClass){
					return function(){
						thisClass.finishProject(thisClass.gameMod.target);
					};})(this));

			console.log(this.gameMod);

			$("#canvasDiv")
				.empty()
				.append(
					$("<span>")
						.css("position","absolute")
						.css("width","700px")
						.css("font-size","100px")
						.css("left","0px")
						.css("text-align","center")
						.css("margin-top","100px")
						.css("user-select","none")
						.html(this.gameMod.target)
				);

			(function(id, className, project, thisClass){
				for(var ids in id){
					$("#canvasDiv").append(
						$("<div>")
							.append(
								$("<canvas>")
									.attr("id",id[ids])
									.attr("class",className)
									.css("position","relative")
									.css("width","100px")
									.css("height","480px")
									//.css("border","solid 2px #1B58B8")
									.css("border-radius","8px")
									.css("background-color","rgba(112,0,149,0.6)")
								)
							.append(
								$("<span>")
									.css("width","100px")
									.css("float","right")
									.css("text-align","center")
									.css("margin","0 auto 0 auto")
									.css("user-select","none")
									.attr("id",id[ids]+"Name")
									.html(id[ids].split("canvas")[1])
								)
							.css("width","100px")
							.css("float","left")
							.css("margin",(function(idNum,idLength){
										return function(){
											if(ids == 0){
												return "0 25px 0 0";
											} else if(ids == idLength-1) {
												return "0 0 0 25px";
											} else {
												return "0 25px 0 25px";
											}
										};
									})(ids,id.length))
							.css("cursor","pointer")
							.click((function(id, project, thisClass){
								return function(e){
									var _type;
									switch(id){
										case "canvasMusic":
											_type = "music";
											break;
										case "canvasSynario":
											_type = "synario";
											break;
										case "canvasDesign":
											_type = "design";
											break;
										case "canvasProgramming":
											_type = "programming";
											break;
										case "canvasGraphics":
											_type = "graphics";
											break;
									}
									thisClass.dev(project.getName(),_type);
									
									console.log(project.getName(),_type,id+" 클릭됨");
								};
							})(id[ids],project,thisClass))
							//.css("border-width","1px")
							//.css("border-color","black")
						)

					switch(id[ids]){
						case "canvasMusic":
							thisClass.drawVars.cvs.music = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.music = thisClass.drawVars.cvs.music.getContext("2d");
							break;
						case "canvasSynario":
							thisClass.drawVars.cvs.synario = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.synario = thisClass.drawVars.cvs.synario.getContext("2d");
							break;
						case "canvasDesign":
							thisClass.drawVars.cvs.design = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.design = thisClass.drawVars.cvs.design.getContext("2d");
							break;
						case "canvasProgramming":
							thisClass.drawVars.cvs.programming = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.programming = thisClass.drawVars.cvs.programming.getContext("2d");
							break;
						case "canvasGraphics":
							thisClass.drawVars.cvs.graphics = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.graphics = thisClass.drawVars.cvs.graphics.getContext("2d");
							break;
					}
					
				}
			})//(["canvasFun","canvasGraphics"],"gameProjectCanvas");
			(["canvasSynario","canvasMusic","canvasDesign","canvasProgramming","canvasGraphics"],"gameProjectCanvas",project,this);

			console.log(this.drawVars);
			
			this.drawVars.interval = setInterval(function(thisClass){
				thisClass.calc();
			},1000/60,this);
		}
	}
	GamEngine.prototype.changeToStudingMod = function(){
		if(this.gameMod.type != "study"){
			if(this.drawVars)
				clearInterval(this.drawVars.interval);
			this.gameMod.type = "study";

			console.log(this.gameMod);			

			$("#completeProjectDiv")
				.css("display","hidden");

			$("#canvasDiv").empty();


			(function(id, className, thisClass){
				var _width = 600/id.length;
				console.log(_width);
				for(var ids in id){
					$("#canvasDiv").append(
						$("<div>").append(
							$("<canvas>")
								.attr("id",id[ids])
								.attr("class",className)
								.css("position","relative")
								.css("width",_width+"px")
								.css("height","480px")
								//.css("border","solid 2px #1B58B8")
								.css("border-radius","8px")
								.css("background-color","#700095")
							)
						.append(
							$("<span>")
								.css("width",_width+"px")
								.css("float","right")
								.css("text-align","center")
								.css("margin","0 auto 0 auto")
								.css("user-select","none")
								.attr("id",id[ids]+"Name")
								.html(id[ids].split("canvas")[1])
							)
						.css("width",_width+"px")
						.css("float","left")
						.css("margin",(function(idNum,idLength){
									return function(){
										if(ids == 0){
											return "0 9px 0 0";
										} else if(ids == idLength-1) {
											return "0 0 0 9px";
										} else {
											return "0 12px 0 12px";
										}
									};
								})(ids,id.length))
						.css("cursor","pointer")
						.click((function(id, thisClass){
							return function(e){
								var _type;
								switch(id){
									case "canvasMusic":
										_type = "music";
										break;
									case "canvasSynario":
										_type = "synario";
										break;
									case "canvasDesign":
										_type = "design";
										break;
									case "canvasProgramming":
										_type = "programming";
										break;
									case "canvasGraphics":
										_type = "graphics";
										break;
								}

								thisClass.study(_type);
								
								console.log(thisClass.mainChar);
								console.log(id+" 클릭됨");
							};
						})(id[ids],thisClass))
							//.css("border-width","1px")
							//.css("border-color","black")
						)
					switch(id[ids]){
						case "canvasMusic":
							thisClass.drawVars.cvs.music = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.music = thisClass.drawVars.cvs.music.getContext("2d");
							break;
						case "canvasSynario":
							thisClass.drawVars.cvs.synario = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.synario = thisClass.drawVars.cvs.synario.getContext("2d");
							break;
						case "canvasDesign":
							thisClass.drawVars.cvs.design = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.design = thisClass.drawVars.cvs.design.getContext("2d");
							break;
						case "canvasProgramming":
							thisClass.drawVars.cvs.programming = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.programming = thisClass.drawVars.cvs.programming.getContext("2d");
							break;
						case "canvasGraphics":
							thisClass.drawVars.cvs.graphics = document.getElementById(id[ids]);
							thisClass.drawVars.ctx.graphics = thisClass.drawVars.cvs.graphics.getContext("2d");
							break;
					}
					console.log("here",thisClass.drawVars);
				}
			})//(["canvasFun","canvasGraphics"],"gameProjectCanvas");
			(["canvasSynario","canvasMusic","canvasDesign","canvasProgramming","canvasGraphics"],"gameProjectCanvas",this);
			//this.createWorld(project);
		}
		this.drawVars.interval = setInterval(function(thisClass){
				thisClass.calc();
		},1000/60,this);
	}
	GamEngine.prototype.changeToNormalMod = function(type){
		if(this.drawVars)
			clearInterval(this.drawVars.interval);
		this.gameMod.type = "normal";
		this.gameMod.target = null;

		$("#completeProjectDiv")
				.css("display","hidden");

		$("#canvasDiv") 
			.empty()
			.append(
				$("<canvas>")
					.attr("id","canvas")
					.attr("class","gameNormal")
			);   
		//<canvas id="canvas" class="gameNormal"></canvas>
	}

	GamEngine.prototype.dev = function(name,type,chara){
		if(type == "random"){
			var temp = Math.floor(Math.random()*5%5)
			console.log(temp);
			type = this.devType[temp];
		}

		for(var id in this.project){
			if(this.project[id].getName() == name){
				console.log(id);
				if(!chara){
					var _success = this.project[id].dev(type,this.mainChar);
					if(_success){
						var times = this.clicked();
						document.getElementById("clickSFX"+times).pause();
						document.getElementById("clickSFX"+times).currentTime = 0;
						document.getElementById("clickSFX"+times).play();
						this.drawVars.bodyArray.push(this.addImg(type,_success));
					}
				} else {
					var _success = this.project[id].dev(type,chara);
					if(_success){
						var times = this.clicked();
						this.drawVars.bodyArray.push(this.addImg(type,_success));
					}
				}

				
				console.log(type,this.mainChar);
			}
		}
	}
	GamEngine.prototype.study = function(type){
		
		console.log("type",type);
		var _success = this.mainChar.changeStatus(type,1);
		if(_success){
			console.log("work");
			var times = this.clicked();
			document.getElementById("clickSFX"+times).pause();
			document.getElementById("clickSFX"+times).currentTime = 0;
			document.getElementById("clickSFX"+times).play();

			this.drawVars.bodyArray.push(this.addImg(type,_success));
		}
	}
	GamEngine.prototype.clicked = function(){
		this.clickTimes++;
		if(this.clickTimes >= 80){
			this.clickTimes = 0;
			return 8;
		}

		return Math.floor(this.clickTimes / 10) + 1;
	}

	GamEngine.prototype.checkGameList = function(){
		return this.project.length;
	}

	GamEngine.prototype.getSelectGame = function(){
		return this.selectedProject;
	}

	GamEngine.prototype.stopForWhile = function(delay){
		this._delay = this.gameDate.absoluteTime+delay;
		this._isDelay = true;

		var left = window.innerWidth/2.0-200, top = window.innerHeight/2.0-200;

		$("#sceneDiv")
			.css("display","block")
			.css("z-index","3");

		$("#scene")
			.css("display","block")
			.attr("src","./res/resting.png")
			.css("left",left+"px")
			.css("top",top+"px");
	}

	GamEngine.prototype.setQue = function(que,delay){
		this._que.push({que:que,delay:this.gameDate.absoluteTime+delay});
	}


	GamEngine.prototype.gameOver = function(){
		this.stopEngine();
		if(!game._isDelay){
			$("#backClick")
				.css("display","block")
				.css("background-color","rgba(0,0,0,0.7)")
				.click(function(){
				})
				.css("z-index","6");
		} else {
			$("#scene")
				.css("display","none");
		}

		$("<img>")
			.attr("src","./res/tombstone.png")
			.css("position","absolute")
			.css("display","none")
			.css("z-index","10")
			.css("left",window.innerWidth/2.0-300)
			.css("top",300)
			.appendTo($("body"))
			.show("slide",{direction :"down",distance:"1000px"},1000,(function(thisClass){
					return function(){
						$("<span>R.I.P.</span>")
							.css("text-align","center")
							.css("font-size","100px")
							.css("position","absolute")
							.css("z-index","11")
							.css("left",window.innerWidth/2.0-150)
							.css("top",450)
							.css("color","gray")
							.append($("<br />"))
							.append($("<span> 1y/1m/1d </span>").css("font-size","30px"))
							.append($("<br />"))
							.append($("<span> ~ </span>").css("font-size","30px"))
							.append($("<br />"))
							.append($("<span>"+thisClass.gameDate.year+"y/"+thisClass.gameDate.month+"m/"+thisClass.gameDate.date+"d</span>").css("font-size","30px"))
							.append($("<br />"))
							.append($("<span> $ "+thisClass.mainChar.moneyRecord+"</span>").css("font-size","30px"))
							.appendTo($("body"));
							
							setTimeout(function(){
								alert("세금을 내지 못해 망했습니다.\n웹페이지를 새로고침 하세요.");},2000);
						};})(this));

		//game.gameOver()
		//R.I.P. 비석
		//YY MM DD 보여주고, 번 돈 보여줌.
	}

	GamEngine.prototype.addImg = function(type,value){
		var imgType = 0;
		if(value >= 10000){
			imgType = "10000";
		} else if(value >= 1000){
			imgType = "1000";
		} else if(value >= 100){
			imgType = "100";
		} else if(value >= 10){
			imgType = "10";
		} else{
			imgType = "";
		}
		var _img = {
			x:Math.floor(Math.random()*200%200),y:Math.floor(Math.random()*50%50)-100,
			type:type,
			img:null
		};

		_img.img = this.resource.image[type+imgType];

		return _img;
	}